﻿// Accord Statistics Library
// The Accord.NET Framework
// http://accord-framework.net
//
// Copyright © César Souza, 2009-2015
// cesarsouza at gmail.com
//
//    This library is free software; you can redistribute it and/or
//    modify it under the terms of the GNU Lesser General Public
//    License as published by the Free Software Foundation; either
//    version 2.1 of the License, or (at your option) any later version.
//
//    This library is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//    Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public
//    License along with this library; if not, write to the Free Software
//    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//

namespace Accord.Statistics.Models.Fields.Learning
{
    using System.Runtime.CompilerServices;
    using Accord.Statistics.Models;
    using Accord.Statistics.Models.Markov;
    using Accord.Statistics.Models.Markov.Hybrid;

    /// <summary>
    ///   Contains learning algorithms for <see cref="ConditionalRandomField{T}">CRFs</see> and
    ///   <see cref="HiddenConditionalRandomField{T}">HCRFs</see>, such as 
    ///   <see cref="HiddenConjugateGradientLearning{T}">Conjugate Gradient</see>, 
    ///   <see cref="HiddenQuasiNewtonLearning{T}">L-BFGS</see> and 
    ///   <see cref="HiddenResilientGradientLearning{T}">RProp-based</see> learning.
    /// </summary>
    /// 
    /// <remarks>
    /// <para>
    ///   The namespace class diagram is shown below. </para>
    ///   <img src="..\diagrams\classes\Accord.Statistics.Models.Fields.png" />
    /// </remarks>
    ///
    /// <seealso cref="Accord.Statistics.Models.Fields"/>
    /// <seealso cref="Accord.Statistics.Models.Fields.Functions"/>
    /// 
    [CompilerGenerated]
    class NamespaceDoc
    {
    }
}
